unit UpDown;
{*
UpDown control
|<br>
|<br>
Version 1.3
|<br>
[*] rewrited, some functions dropped; changing buddy control and some options at
 run-time is not allowed (require to recreate control), but object code is now
 compact and MCK better becouse of more properties: AlignButton,ArrowKeys,
 Orientation,Thousands,Wrap - exactly like in VCL ;-)
 |<br>
 [+] OnChanging changed ; now it is possible to disallow change of updown position
 in this event
 |<br>
Version 1.2
|<br>
  [-] corrected access violation bug in Associate property
|<br>
  [-] corrected bad positioning of control when  Glue = True
|<br>
  [+] ptWYSIWIG painting implemented
|<br>
Notice : still there is a bug when attempting to align  to another control :-(
|<br>
Version 1.1
|<br>
  [+] MCK Associate allow  visually select associated (buddy) control
      (however Access Violation occurs when this property is set to nil)
|<br>
  [+] Options property allow change style of control at run-time (updown control is recreated)
|<br>
  [+] Glue property
|<br>
|<br>

Bugs to correct:
|<br>
  - when setting Associate property Access Violation occurs
|<br>
  - attempt to align TKOLUpDown to another control causes  crash of Delphi IDE
  (but succesion is important: first another control then TKOLUpDown)
|<br>
|<br>
Todo :
|<br>
  - in OnChanging possibility to forbid changes
|<br>
|<br>

Version 1.0
|<br>
  Initial release.
|<br>
Author : Boguslaw Brandys (brandysb@poczta.onet.pl)
}

interface
uses Windows,KOL,Messages;

const
  REFRESH_PERIOD : Cardinal = 1;
  {* Amount of elapsed time, in seconds, before the position
  change increment is used.}


type
  TUpDownBase = (upDecimal,upHex);
  {* associated control's caption may be either in decimal or hexadecimal unit formated}
  TUpDownOption = (updWrap,updSetBuddy,updAlignRight,updAlignLeft,
    updAutoBuddy,updArrows,updHorz,updNoThousands);
  {* Options:
  |<br>
  updWrap : wrap position value if it is incremented or decremented beyond
  the ending or beginning of the range.
  |<br>
  updSetBuddy : set the text of associated control's window (buddy window)
  whenever position changes
  |<br>
  updAlignRight,updAlignLeft : positions the up-down control next to the
  right or left edge of the buddy window. The width of the buddy window
  is decreased to accommodate the width of the up-down control.
  |<br>
  updAutoBuddy : automatically selects the previous control in the Z order
  (last created control)as the up-down control's buddy window
  |<br>
  updArrows : allow using arrow keys to change up-down position
  |<br>
  updHorz : causes the up-down control's arrows to point left and right
  instead of up and down.
  |<br>
  updNoThousands : does not insert a thousands separator between
  every three decimal digits in the text of associated control's window
  }
  TUpDownOptions = Set of TUpDownOption;
  {*}


type
  TOnChanging = procedure(Sender : PObj; OldPosition : SmallInt; NewPosition : SmallInt;var Allow : Boolean) of object;
  {* Event fired when position is about to change.Notice that OldPosition is equal to NewPosition
  beyond  Max or Min position.Set Allow to false to disallow change of position property.
  }

type
  PUpDown = ^TUpDown;
  TKOLUpDown = PUpDown;
  TUpDown = object(TObj)
  {*}
  private
   fUpDown     : PControl;
   fBuddy      : PControl;//associated control
   fHandle     : THandle;
   fOnChanging : TOnChanging;
   fMax,fMin   : SmallInt;
  protected
  function GetHandle : THandle;
  function GetCursor : HCURSOR;
  procedure SetCursor(const Value : HCURSOR);
  procedure SetEnabled(const Value : Boolean);
  function GetEnabled : Boolean;
  procedure SetVisible(const Value : Boolean);
  function GetVisible : Boolean;
  procedure SetBuddy(const Value : PControl);
  function  GetBuddy : PControl;
  procedure SetPos(const Value : SmallInt);
  function GetPos : SmallInt;
  procedure SetMax(const Value : SmallInt);
  function GetMax : SmallInt;
  procedure SetMin(const Value : SmallInt);
  function GetMin : SmallInt;
  procedure SetIncrement(const Value : Integer);
  function GetIncrement : Integer;
  procedure SetBase(const Value: TUpDownBase);
  function GetBase : TUpDownBase;
  public
  { Public declarations }
  destructor Destroy; virtual;
  {*}
  function SetPosition(X, Y: integer): PUpDown; overload;
  {*}
  function SetSize(X, Y: integer): PUpDown; overload;
  {*}
  function SetAlign(Value: TControlAlign): PUpDown;overload;
  {*}
//  function AssignHelpContext(const Value : Integer) : PUpDown;overload;
//  {*}
  property Handle : THandle read GetHandle;
  {*}
  property Cursor : HCURSOR read GetCursor write SetCursor;
  {*}
  property Enabled : Boolean read GetEnabled write SetEnabled;
  {*}
  property Visible : Boolean read GetVisible write SetVisible;
  {*}
  property Associate : PControl read GetBuddy write SetBuddy;
  {* Allow associate buddy control with TKOLUpDown.In MCK setting this property cause
  TKOLUpDown to be positioned near buddy control.}
  property Position : SmallInt read GetPos write SetPos;
  {* Current up-down position}
  property Max : SmallInt read GetMax write SetMax;
  {* Maximum position which is allowed}
  property Min : SmallInt read GetMin write SetMin;
  {* Minimum position.}
  property Increment : Integer read GetIncrement write SetIncrement;
  {*  Position change increment}
  property Base : TUpDownBase read GetBase write SetBase;
  {* Format of associated control's text}
  property OnChanging : TOnChanging read fOnChanging write  fOnChanging;
  {* }
  end;





  function NewUpDown(AOwner : PControl; Options : TUpDownOptions) : PUpDown;
  {* Global function to create TKOLUpDown control}



implementation

const
  UPDOWN_CLASS = 'msctls_updown32';
  UD_MAXVAL               = $7fff;
  UD_MINVAL               = -UD_MAXVAL;
  UDS_WRAP                = $0001;
  UDS_SETBUDDYINT         = $0002;
  UDS_ALIGNRIGHT          = $0004;
  UDS_ALIGNLEFT           = $0008;
  UDS_AUTOBUDDY           = $0010;
  UDS_ARROWKEYS           = $0020;
  UDS_HORZ                = $0040;
  UDS_NOTHOUSANDS         = $0080;


  UDM_SETRANGE            = WM_USER+101;
  UDM_GETRANGE            = WM_USER+102;
  UDM_SETPOS              = WM_USER+103;
  UDM_GETPOS              = WM_USER+104;
  UDM_SETBUDDY            = WM_USER+105;
  UDM_GETBUDDY            = WM_USER+106;
  UDM_SETACCEL            = WM_USER+107;
  UDM_GETACCEL            = WM_USER+108;
  UDM_SETBASE             = WM_USER+109;
  UDM_GETBASE             = WM_USER+110;

  UDN_FIRST    = 0-721;
  UDN_DELTAPOS = UDN_FIRST - 1;


type
  NM_UPDOWN = packed record
    hdr: TNMHDR;
    iPos: Integer;
    iDelta: Integer;
  end;
  TNMUpDown = NM_UPDOWN;
  PNMUpDown = ^TNMUpDown;

type
  UDACCEL = packed record
    nSec: UINT;
    nInc: UINT;
  end;
  TUDAccel = UDACCEL;
  PUDAccel = ^TUDAccel;


const  UpDownFlags : array[TUpDownOption] of Integer = (UDS_WRAP,UDS_SETBUDDYINT,
UDS_ALIGNRIGHT,UDS_ALIGNLEFT,UDS_AUTOBUDDY,UDS_ARROWKEYS,UDS_HORZ,UDS_NOTHOUSANDS);







function UpDownWndProc(Sender : PControl;var Msg:TMsg;var Rslt:Integer):Boolean;
var
  NMUpDown  : PNMUpDown;
  UpDownNow : PUpDown;
  NewPos : Integer;
  Allow : Boolean;
begin
  Result := False;
  Allow := True;
  if Msg.message = WM_NOTIFY then
  begin
    NMUpDown := PNMUpDown(Msg.lParam);
    if NMUpDown.hdr.code = UDN_DELTAPOS then
      begin
      UpDownNow := PUpDown(Sender.Tag);
      NewPos := NMUpDown.iPos + NMUpDown.iDelta;//new position
      if NewPos > UpDownNow.fMax then NewPos := UpDownNow.fMax;
      if NewPos < UpDownNow.fMin then NewPos := UpDownNow.fMin;
      if assigned(UpDownNow.fOnChanging) then begin
        UpDownNow.fOnChanging(PObj(UpDownNow),NMUpDown.iPos,NewPos,Allow);
        Result := true;
        if not Allow then Rslt := 1
        else
        Rslt := 0;
        end;
      end;
    end;
end;




function NewUpDown(AOwner : PControl; Options : TUpDownOptions) : PUpDown;
var
  Flags : Integer;
begin
        New(Result,Create);
        AOwner.Add2AutoFree(Result);
        DoInitCommonControls(ICC_UPDOWN_CLASS);
        Flags := MakeFlags(@Options,UpDownFlags);
        Result.fUpDown :=  _NewCommonControl(AOwner,UPDOWN_CLASS,
            WS_VISIBLE or  WS_CHILD or Flags,False,nil);
        Result.fUpDown.ExStyle  := WS_EX_CLIENTEDGE;
        Result.fUpDown.TabStop := False;
        Result.fUpDown.HasBorder := False;
        Result.fHandle := Result.fUpDown.GetWindowHandle;
        Result.fUpDown.Parent := AOwner;
        Result.fUpDown.Tag := Longint(Result);
        Result.fMax := 100;
        Result.fMin := 0;
        Result.fUpDown.AttachProc(UpDownWndProc);
end;


destructor TUpDown.Destroy;
begin
  fUpDown.Free;
  inherited;
end;




procedure TUpDown.SetBuddy(const Value : PControl);
begin
  fBuddy := Value;
  if (Value <> nil) then  SendMessage(fHandle,UDM_SETBUDDY,LongInt(Value.GetWindowHandle),0);
end;

function  TUpDown.GetBuddy : PControl;
begin
  Result := fBuddy;
end;


procedure TUpDown.SetPos(const Value : SmallInt);
begin
  SendMessage(fHandle,UDM_SETPOS,0,MAKELONG(Value,0));
end;

function TUpDown.GetPos : SmallInt;
var
  j : Integer;
begin
 j := SendMessage(fHandle,UDM_GETPOS,0,0);
 if HiWord(j) <> 0 then Result := UD_MAXVAL
 else
 Result := LoWord(j);
end;

procedure TUpDown.SetMax(const Value : SmallInt);
begin
      fMax := Value;
      SendMessage(fHandle,UDM_SETRANGE,0,MAKELONG(fMax,fMin));
end;

function TUpDown.GetMax : SmallInt;
begin
  Result := SmallInt(LoWord(SendMessage(fHandle,UDM_GETRANGE,0,0)));
end;

procedure TUpDown.SetMin(const Value : SmallInt);
begin
      fMin := Value;
      SendMessage(fHandle,UDM_SETRANGE,0,MAKELONG(fMax,fMin));
end;


function TUpDown.GetMin : SmallInt;
begin
  Result := SmallInt(HiWord(SendMessage(fHandle,UDM_GETRANGE,0,0)));
end;

procedure TUpDown.SetIncrement(const Value : Integer);
var
  acc : TUDAccel;
begin
  acc.nSec := REFRESH_PERIOD;
  acc.nInc := Cardinal(Value);
  SendMessage(fHandle,UDM_SETACCEL,1,LongInt(@acc));
end;

function TUpDown.GetIncrement : Integer;
var
  count : LongInt;
  acc   : TUDAccel;
begin
  SendMessage(fHandle,UDM_GETACCEL,LongInt(@count),LongInt(@acc));
  Result := acc.nInc;
end;

procedure TUpDown.SetBase(const Value: TUpDownBase);
begin
  if Value = upDecimal then
  SendMessage(fHandle,UDM_SETBASE,10,0)
  else
  SendMessage(fHandle,UDM_SETBASE,16,0);
end;

function TUpDown.GetBase : TUpDownBase;
var
  j : Integer;
begin
  j := SendMessage(fHandle,UDM_GETBASE,0,0);
  if j=10 then
    Result := upDecimal
      else
        Result := upHex;
end;





function TUpDown.SetPosition(X, Y: integer): PUpDown;
begin
   fUpDown.Left := X;
   fUpDown.Top := Y;
   Result := @self;
end;

function TUpDown.SetSize(X, Y: integer): PUpDown;
begin
   fUpDown.Width  := X;
   fUpDown.Height := Y;
   Result := @self;
end;


function TUpDown.SetAlign(Value: TControlAlign): PUpDown;
begin
  fUpDown.Align:=Value;
  Result:=@self;
end;

{
function TUpDown.AssignHelpContext(const Value : Integer): PUpDown;
begin
  fUpDown.HelpContext:=Value;
  Result:=@self;
end;
}

procedure TUpDown.SetCursor(const Value : HCURSOR);
begin
	fUpDown.Cursor := Value;
end;

function TUpDown.GetCursor : HCURSOR;
begin
  Result := fUpDown.Cursor;
end;


procedure TUpDown.SetEnabled(const Value : Boolean);
begin
  fUpDown.Enabled := Value;
end;

function TUpDown.GetEnabled : Boolean;
begin
  Result := fUpDown.Enabled;
end;

procedure TUpDown.SetVisible(const Value : Boolean);
begin
  fUpDown.Visible := Value;
end;

function TUpDown.GetVisible : Boolean;
begin
  Result := fUpDown.Visible;
end;

function TUpDown.GetHandle : THandle;
begin
  Result := fHandle;
end;



end.
