unit mckUpDown;

interface

{$R updown.res}

uses
Windows, Messages, mirror, classes, Controls, Forms, KOL,UpDown, mckCtrls,Graphics;

type
  TButtonAlign = (aRight,aLeft);
  TButtonOrientation = (Vertical,Horizontal);


  TKOLUpDown = class(TKOLControl)
  private
  fBase : TUpDownBase;
  fPosition,fMin,fMax : SmallInt;
  fIncrement : Integer;
  fBuddy : TKOLControl;
  fOnChanging : TOnChanging;
  fWrap,fArrowKeys,fAutoBuddy,fThousands : Boolean;
  fButtonOrientation : TButtonOrientation;
  fButtonAlign : TButtonAlign;
  fBitH,fBitV : TBitmap;//used for loading resource in ptWYSIWIG mode
  { fake}
  fFake : Boolean;
  protected
    procedure AssignEvents(SL: TStringList; const AName: String);override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String );override;
    procedure SetupLast( SL: TStringList; const AName, AParent, Prefix: String );override;
    function  SetupParams(const AName,AParent : String) : String;override;
    function  AdditionalUnits: string; override;
    procedure SetOnChanging(const Value : TOnChanging);
    procedure SetButtonAlign(const Value : TButtonAlign);
    procedure SetArrowKeys(const Value : Boolean);
    procedure SetButtonOrientation(const Value  : TButtonOrientation);
    procedure SetThousands(const Value : Boolean);
    procedure SetAutoBuddy(const Value : Boolean);
    procedure SetWrap(const Value : Boolean);
    procedure SetBase(const Value : TUpDownBase);
    procedure SetMax(const Value : SmallInt);
    procedure SetMin(const Value : SmallInt);
    procedure SetPos(const Value : SmallInt);
    procedure SetIncrement(const Value : Integer);
    procedure SetAssociate(const Value : TKOLControl);
    procedure Paint;override;
    function  WYSIWIGPaintImplemented: Boolean;override;
  public
    constructor Create( AOwner: TComponent ); override;
    destructor Destroy;override;
  published
  property Position : SmallInt read fPosition write SetPos;
  property Max : SmallInt read fMax write SetMax;
  property Min : SmallInt read fMin write SetMin;
  property Increment : Integer read fIncrement write SetIncrement;
  property AlignButton : TButtonAlign read fButtonAlign write SetButtonAlign;
  property ArrowKeys : Boolean read fArrowKeys write SetArrowKeys;
  property Orientation : TButtonOrientation read fButtonOrientation write SetButtonOrientation;
  property Thousands  : Boolean read fThousands write SetThousands;
  property Wrap : Boolean read fWrap write SetWrap;
  property AutoBuddy : Boolean read fAutoBuddy write SetAutoBuddy;
  property Base : TUpDownBase read fBase write SetBase;
  property Associate : TKOLControl read fBuddy write SetAssociate;
  property OnChanging : TOnChanging read fOnChanging write SetOnChanging;
  { Fake properties}
  property Color : Boolean write fFake;
  property Font : Boolean write fFake;
  property Caption : Boolean write fFake;
  property CenterOnParent : Boolean write fFake;
  property EraseBackground : Boolean write fFake;
  property MaxHeight : Boolean write fFake;
  property MaxWidth : Boolean write fFake;
  property parentFont : Boolean write fFake;
  property parentColor : Boolean write fFake;
  property TabOrder : Boolean write fFake;
  property TabStop : Boolean  write fFake;
  property Tag : Boolean write fFake;
  property PlaceDown : Boolean write fFake;
  property PlaceRight : Boolean write fFake;
  property PlaceUnder : Boolean write fFake;
  property DoubleBuffered : Boolean write fFake;
  property MinHeight : Boolean write fFake;
  property MinWidth : Boolean write fFake;
  property Cursor : Boolean write fFake;
  property OnClick : Boolean write fFake;
  property OnDropFiles : Boolean write fFake;
  property OnEraseBkgnd : Boolean write fFake;
  property OnHide : Boolean write fFake;
  property OnMessage : Boolean write fFake;
  property OnMouseDblClk : Boolean write fFake;
  property OnMouseDown : Boolean write fFake;
  property OnMouseEnter : Boolean write fFake;
  property OnMouseLeave : Boolean write fFake;
  property OnMouseMove : Boolean write fFake;
  property OnMouseUp : Boolean write fFake;
  property OnMouseWheel : Boolean write fFake;
  property OnMove : Boolean write fFake;
  property OnPaint : Boolean write fFake;
  property OnResize : Boolean write fFake;
  property OnShow : Boolean write fFake;
  property HelpContext : Boolean write fFake;
  end;

  procedure Register;

implementation

{$R *.dcr}




constructor TKOLUpDown.Create( AOwner: TComponent );
begin
inherited;
fBitH := TBitmap.Create;
fBitV := TBitmap.Create;
fBitH.LoadFromResourceName(hInstance,'UPDOWNH');
fBitV.LoadFromResourceName(hInstance,'UPDOWNV');
fMax := 100;
fMin := 0;
Width := 13;
Height := 22;
fIncrement := 1;
fPosition := 0;
fArrowKeys := true;
fThousands := false;
fButtonAlign := aRight;
fButtonOrientation := Vertical;
fWrap := false;
fAutoBuddy := false;
end;

destructor TKOLUpDown.Destroy;
begin
 fBitH.Free;
 fBitV.Free;
 inherited;
end;




function TKOLUpDown.AdditionalUnits;
begin
   Result := ', UpDown';
end;

procedure TKOLUpDown.SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
  begin
    inherited;
    if fMax <> 100 then SL.Add(Prefix + AName + '.Max := ' + Int2Str(fMax) + ';');
    if fMin <> 0 then SL.Add(Prefix + AName + '.Min := ' + Int2Str(fMin) + ';');
    if fIncrement <> 1 then SL.Add(Prefix + AName + '.Increment := ' + Int2Str(fIncrement) + ';');
    if fBase <> upDecimal then SL.Add(Prefix + AName + '.Base := upHex;');
  end;


procedure TKOLUpDown.SetupLast( SL: TStringList; const AName,
 AParent, Prefix: String );
 begin
    inherited;
    if fBuddy  <> nil then SL.Add(Prefix + AName + '.Associate := Result.' + fBuddy.Name + ';');
    if fPosition <> 0 then SL.Add(Prefix + AName + '.Position := ' + Int2Str(fPosition) + ';');
 end;

function TKOLUpDown.SetupParams(const AName,AParent : String) : String;
var
  s : String;
begin
    s :='';
    if fWrap then s := s + ',updWrap';
    if fAutoBuddy then s := s + ',updAutoBuddy';
    if fArrowKeys then s := s + ',updArrows';
    if not fThousands then s := s + ',updNoThousands';
    if Assigned(fBuddy) then  s := s + ',updSetBuddy';
    if fButtonAlign = aLeft then s := s + ',updAlignLeft'
    else
    s := s + ',updAlignRight';
    if fButtonOrientation = Horizontal then s := s + ',updHorz';
    if s <> '' then
      if s[1] = ',' then s[1] := Chr(32);
    Result := AParent + ',' + '[' + s + ']';
    Invalidate;
end;

procedure TKOLUpDown.AssignEvents(SL: TStringList; const AName: String);
begin
  inherited;
  DoAssignEvents( SL, AName,[ 'OnChanging'],[ @OnChanging]);
end;




procedure TKOLUpDown.SetOnChanging(const Value : TOnChanging);
begin
  fOnChanging := Value;
  Change;
end;



procedure TKOLUpDown.SetBase(const Value : TUpDownBase);
begin
  if Value <> fBase then begin
    fBase := Value;
    Change;
  end;
end;

procedure TKOLUpDown.SetMax(const Value : SmallInt);
begin
  if Value <> fMax then begin
    fMax := Value;
    Change;
  end;
end;

procedure TKOLUpDown.SetMin(const Value : SmallInt);
begin
  if Value <> fMin then begin
    fMin := Value;
    Change;
  end;
end;

procedure TKOLUpDown.SetPos(const Value : SmallInt);
begin
  if Value <> fPosition then begin
    fPosition := Value;
    Change;
  end;
end;

procedure TKOLUpDown.SetIncrement(const Value : Integer);
begin
  if Value <> fIncrement then begin
    fIncrement := Value;
    Change;
  end;
end;



procedure TKOLUpDown.SetAssociate(const Value : TKOLControl);
begin
  fBuddy := Value;
  if Value <> nil then
    begin
      Top := fBuddy.Top;
      Height := fBuddy.Height;
      if fButtonAlign = aRight then
          Left := fBuddy.Left + fBuddy.Width
            else
              Left := fBuddy.Left - Width;
      end;
  Change;
  Invalidate;
end;


procedure TKOLUpDown.SetButtonAlign(const Value : TButtonAlign);
begin
  if Value <> fButtonAlign then begin
    fButtonAlign := Value;
    if Assigned(fBuddy) then begin
      Top := fBuddy.Top;
      Height := fBuddy.Height;
      if fButtonAlign = aRight then
          Left := fBuddy.Left + fBuddy.Width
            else
              Left := fBuddy.Left - Width;
    end;
  Change;
  Invalidate;
  end;
end;


procedure TKOLUpDown.SetArrowKeys(const Value : Boolean);
begin
  if Value <> fArrowKeys then begin
    fArrowKeys := Value;
    Change;
  end;
end;


procedure TKOLUpDown.SetButtonOrientation(const Value  : TButtonOrientation);
begin
  if Value <> fButtonOrientation then begin
    fButtonOrientation := Value;
    Change;
    Invalidate;
  end;
end;


procedure TKOLUpDown.SetThousands(const Value : Boolean);
begin
  if Value <> fThousands then begin
    fThousands := Value;
    Change;
  end;
end;


procedure TKOLUpDown.SetWrap(const Value : Boolean);
begin
  if Value <> fWrap then begin
    fWrap := Value;
    Change;
  end;
end;

procedure TKOLUpDown.SetAutoBuddy(const Value : Boolean);
begin
  if Value <> fAutoBuddy then begin
    fAutoBuddy := Value;
    Change;
  end;
end;





function TKOLUpDown.WYSIWIGPaintImplemented: Boolean;
begin
  Result := TRUE;
end;

procedure TKOLUpDown.Paint;
var
  R:TRect;
  cBitmap : TBitmap;
begin
  if fButtonOrientation = Horizontal then cBitmap := fBitH
  else
  cBitmap := fBitV;
  R.Left:=0;
  R.Top:=0;
  R.Right:=Width;
  R.Bottom:=Height;
  Canvas.StretchDraw(R,cBitmap);
  inherited;
end;


procedure Register;
begin
  RegisterComponents('KOL', [TKOLUpDown]);
end;

end.

